package com.tacademy.data;

import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import com.tacademy.data.ToDuckDatabase.drawInit;
import com.tacademy.data.ToDuckDatabase.todoList;

public class ToDuckDatabaseHelper extends SQLiteOpenHelper{
	
	private static final String DATABASE_NAME = "toduck.db";
    private static final int DATABASE_VERSION = 3;
	
	public ToDuckDatabaseHelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }
	
	@Override
	public void onCreate(SQLiteDatabase db) {
		// Create the card table
		db.execSQL("CREATE TABLE " +  todoList.TODO_TABLE_NAME + " ( " 
				+ todoList.INDEX + " INTEGER PRIMARY KEY ," 
				+ todoList.IMAGE + " TEXT , "
				+ todoList.CHECK  + " INTEGER , "
				+ todoList.WIDGET  + " INTEGER , "
				+ todoList.NOTI  + " INTEGER , "
				+ todoList.NOTI_DATE  + " datetime "
				+ ");");	
		
//	db.execSQL("INSERT INTO todoList (imagePath, checked, widget, noti, notiDate) VALUES('/data/data/com.tacademy/1.jpg', 1, 0, 0,'2010-10-10')");
	}
	
	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		db.execSQL("CREATE TABLE " +  drawInit.DRAW_TABLE_NAME + " ( " 
				+ drawInit.INDEX + " INTEGER PRIMARY KEY ," 
				+ drawInit.WIDTH + " INTEGER ," 
				+ drawInit.COLOR + " INTEGER , "
				+ drawInit.SCROLL  + " INTEGER, "
				+ drawInit.COLOR1  + " INTEGER, "
				+ drawInit.COLOR2  + " INTEGER, "
				+ drawInit.COLOR3  + " INTEGER "
				+ ");");
		
		db.execSQL("INSERT INTO drawInit (drawIndex, width, color, scroll, color1, color2, color3) VALUES(1, 16, -1, 1, -256, -65536, -16711681)");
	}

	@Override
	public void onOpen(SQLiteDatabase db) {
		super.onOpen(db);
	}
	
	public void logCursorInfo(Cursor c,String tag)
	{
		Log.i(tag,"*** Cursor Begin ***" + " Result:" + c.getCount() + " Colums: " + 
				c.getColumnCount());
		
		String rowHeaders = "|| ";
		
		for (int i = 0 ; i < c.getColumnCount() ; i++)
		{
			rowHeaders = rowHeaders.concat(c.getColumnName(i) + " || ");
		}
		
		Log.i(tag,"COLUMNS " + rowHeaders);
		
		c.moveToFirst();
		while(c.isAfterLast() == false)
		{
			
			String rowResults = "|| ";
			for (int i = 0; i < c.getColumnCount() ; i++)
			{
				rowResults = rowResults.concat(c.getString(i) + " || ");
			}
			
			Log.i(tag,"Row " + c.getPosition() +": " + rowResults);
			
			c.moveToNext();
		}
	}
	
	
}
